﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TwelvePx.Graphics;
using TwelvePx.Interfaces;
using TwelvePx.Screens;
using TwelvePx.Elements;
using SFML.Graphics;
using SFML.Window;

namespace TwelvePx.Core
{
    public class GameContext : Drawable
    {
        public GameEngine Engine { get; private set; }
        public GameScreen Screen { get; private set; }
        public Player Player { get; private set; }

        public Map CurrentMap { get; set; }

        public GameContext(GameEngine Engine, GameScreen Screen)
        {
            this.Engine = Engine;
            this.Screen = Screen;

            Player = new Player(this);
            CurrentMap = new Map(4, 3, System.IO.File.ReadAllText("Levels\\01.level"));

            Player.SetPosition(CurrentMap.StartColumn, CurrentMap.StartRow);

            CurrentMap.RenderPlayerRect(Player);
        }

        public void Update(float Delta)
        {
            
        }

        public void Draw(RenderTarget target, RenderStates states)
        {
            target.Draw(CurrentMap, states);
            target.Draw(Player, states);
        }

        public void Destroy()
        {

        }

        public void OnKeyPress(KeyEventArgs Args, ref bool Handled)
        {
            if (Args.Code == Keyboard.Key.Up || Args.Code == Keyboard.Key.W) // Up
            {
                if (Player.CanMoveUp)
                {
                    Player.RelativeMove(0, -1);
                }
            }
            else if (Args.Code == Keyboard.Key.Down || Args.Code == Keyboard.Key.S) // Down
            {
                if (Player.CanMoveDown)
                {
                    Player.RelativeMove(0, 1);
                }
            }
            else if (Args.Code == Keyboard.Key.Left || Args.Code == Keyboard.Key.A) // Left
            {
                if (Player.CanMoveLeft)
                {
                    Player.RelativeMove(-1, 0);
                }
            }
            else if (Args.Code == Keyboard.Key.Right || Args.Code == Keyboard.Key.D) // Right
            {
                if (Player.CanMoveRight)
                {
                    Player.RelativeMove(1, 0);
                }
            }

            CurrentMap.RenderPlayerRect(Player);
        }

        public void OnKeyRelease(KeyEventArgs Args, ref bool Handled)
        {

        }
    }
}
