﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TwelvePx.Elements;
using SFML.Graphics;
using TwelvePx.Graphics;

namespace TwelvePx.Tools
{
    public static class Block
    {
        public static Dictionary<BlockType, Color> BlockLookup { get; private set; }

        static Block()
        {
            BlockLookup = new Dictionary<BlockType, Color>();
            BlockLookup.Add(BlockType.VoidBlock, Color.Black);
            BlockLookup.Add(BlockType.SolidBlock, Color.White);
            BlockLookup.Add(BlockType.FinishBlock, Color.Blue);
        }

        public static bool CanTouch(BlockType Block)
        {
            if (Block != BlockType.SolidBlock && Block != BlockType.TeleportBlock1Out && Block != BlockType.TeleportBlock2Out)
                return true;
            return false;
        }

        public static void Touch(Player Player, Map Map, BlockType Block)
        {
            if (Block == BlockType.FinishBlock)
            {
                Player.Context.Engine.Destroy();
            }
        }
    }
}
