﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SFML.Graphics;
using SFML.Window;

namespace TwelvePx.Interfaces
{
    public interface IScreen : Drawable
    {
        void Update(float Delta);
        void OnKeyPress(KeyEventArgs Args, ref bool Handled);
        void OnKeyRelease(KeyEventArgs Args, ref bool Handled);
        void OnClose(ref bool Cancel);
        void OnResize(SizeEventArgs Args);
        void OnFocusGain();
        void OnFocusLose();
        void OnTextInput(TextEventArgs Args, ref bool Handled);
        void OnMouseMove(MouseMoveEventArgs Args, ref bool Handled);
        void OnMouseEnter();
        void OnMouseLeave();
        void OnMouseButtonPress(MouseButtonEventArgs Args, ref bool Handled);
        void OnMouseButtonRelease(MouseButtonEventArgs Args, ref bool Handled);
        void Destroy();
    }
}
